testStat <- function(sumFns,A,B,AB,Khat,wts,s2,r,type) {
# Test statistic.
# type <--> "oneway", "addit", "interac".
#
w <- sum(wts)
if(type %in% c("oneway","addit")) {
    kays <- wtdMeans(sumFns,wts,splif=A)
    wi.  <- sapply(split(wts,f=A),sum)
    enns <- table(A)
    vmlt <- 1/wi. - 1/w
    M <- (do.call(cbind,kays) - Khat)^2
    V <- outer(s2,vmlt,"*")
    M <- M/V
    T <- apply(M,2,trapint,r=r)
    T <- sum(enns*T)
} else if(type=="interac") {
    na   <- length(levels(A))
    nb   <- length(levels(B))
    nc   <- length(r)
    kAB  <- wtdMeans(sumFns,wts,splif=AB)
    mAB  <- do.call(cbind,kAB)
    aAB  <- aperm(array(t(mAB),dim=c(nb,na,nc)),c(2,1,3))
    kA   <- wtdMeans(sumFns,wts,splif=A)
    mA   <- do.call(cbind,kA)
    kB   <- wtdMeans(sumFns,wts,splif=B)
    mB   <- do.call(cbind,kB)
    sAB  <- lapply(1:nc,function(k,x,y){outer(x[k,],y[k,],"+")},x=mA,y=mB)
    tAB  <- array(unlist(sAB),dim=c(na,nb,nc))
    uAB  <- aperm(array(Khat,dim=c(nc,na,nb)),c(2,3,1))
    enns <- table(A,B)
    M    <- (aAB - tAB + uAB)^2
    wij. <- matrix(sapply(split(wts,f=AB),sum),
                   nrow=na,ncol=nb,byrow=TRUE)
    wi.. <- sapply(split(wts,f=A),sum)
    w.j. <- sapply(split(wts,f=B),sum)
    oij  <- outer(wi..,w.j.,"+")
    orij <- outer(1/wi..,1/w.j.,"+")
    vmlt <- 1/wij. - orij + 2*wij./oij - 1/w
    V    <- aperm(outer(s2,vmlt,"*"),c(2,3,1))
    M    <- M/V
    T    <- apply(M,c(1,2),trapint,r=r)
    T    <- sum(enns*T)
} else {
    stop(paste0("Value of \"type\" ",type," not recognised.\n"))
}
T
}
